using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

// ^C̎Q
using DemoTypes;

// fobOR|[lg̎Q
using ShaderInstancingTest02.GameDebug;


namespace ShaderInstancingTest02
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;


        #region 萔錾

        // \f
        public const int InitialGameObjectCount = 1000;

        // ő\f
        public const int MaxGameObjectCount = 50000;

        #endregion


        #region tB[h

        // fobO}l[W[
        DebugManager debugManager;
        // fobOR}hUI
        DebugCommandUI debugCommandUI;
        // FPSJE^[
        FpsCounter fpsCounter;
        // ^C[[
        TimeRuler timeRuler;


        // Q[IuWFNgړł̈
        public static BoundingBox Sandbox = new BoundingBox();

        // ^[QbgQ[IuWFNg\
        int targetObjectCount = InitialGameObjectCount;

        // Q[IuWFNgz
        GameObject[] gameObjects;

        // mۂĂQ[IuWFNg
        int gameObjectCount;

        // Q[IuWFNgɎgCX^X
        Random rnd = new Random(0);

        // JW
        Vector3 cameraPosition;

        // r[s
        Matrix view;

        // ˉes
        Matrix projection;

        // CX^Xpf
        InstancedModel instancedModel;

        // VF[_[CX^Xp̃VF[_[萔i[pz
        Vector4[] instanceParam0 = new Vector4[100];
        Vector4[] instanceParam1 = new Vector4[100];

        // `p̃CX^Xi[ׂ̔z
        // ObjectInstanceVertex[] objectInstances =
        //                                 new ObjectInstanceVertex[MaxGameObjectCount];

        #endregion

        #region 

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            // fobO}l[W[̏ƒǉ
            debugManager = new DebugManager(this);
            Components.Add(debugManager);

            // fobO}R}hUȈƒǉ
            debugCommandUI = new DebugCommandUI(this);

            // fobOR}hUIŏʂɕ\ׂDrawOrderύX
            debugCommandUI.DrawOrder = 100;

            Components.Add(debugCommandUI);

            // FPSJE^[̏ƒǉ
            fpsCounter = new FpsCounter(this);
            Components.Add(fpsCounter);

            // ^C[[̏ƒǉ
            timeRuler = new TimeRuler(this);
            Components.Add(timeRuler);


            base.Initialize();
        }

        #endregion


        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here


            // f̓ǂݍ
            instancedModel = Content.Load<InstancedModel>("Fence02/instanced-Fence02Box");

            instancedModel.SetInstancingTechnique(
                                        InstancingTechnique.ShaderInstancing, null);


            // JWAr[Aˉes̐ݒ
            float aspectRatio = GraphicsDevice.Viewport.AspectRatio;

            cameraPosition = new Vector3(0, 0, 30);
            view = Matrix.CreateLookAt(cameraPosition, Vector3.Zero, Vector3.Up);

            projection = Matrix.CreatePerspectiveFieldOfView(
                            MathHelper.ToRadians(30.0f), aspectRatio, 1.0f, 1000.0f);

            // f̈ړ͈͂̐ݒ
            float sandBoxSize = 20.0f;
            Sandbox.Min.X = sandBoxSize * -0.5f * aspectRatio;
            Sandbox.Min.Y = sandBoxSize * -0.5f;
            Sandbox.Max.X = sandBoxSize * 0.5f * aspectRatio;
            Sandbox.Max.Y = sandBoxSize * 0.5f;

            // Q[IuWFNg̏
            InitializeGameObjects();


            // FPSJE^[\
            // fpsCounter.Visible = true;
            // ^C[[\
            // timeRuler.Visible = true;
            //  ^C[[Log\
            // timeRuler.ShowLog = true;
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // ^C[[Ƀt[Jn`
            timeRuler.StartFrame();
            // XVԁA"Update"̑Jn
            timeRuler.BeginMark("Update", Color.Blue);


            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here


            float dt = (float)gameTime.ElapsedGameTime.TotalSeconds;

            // SQ[IuWFNg̍XV
            UpdateGameObjects(dt);


            base.Update(gameTime);


            // XVԁA"Update"̑I
            timeRuler.EndMark("Update");
        }


        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            // `ԁA"Draw"̑Jn
            timeRuler.BeginMark("Draw", Color.Yellow);


            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here


            // Q[IuWFNg̕`
            DrawGameObjects();


            base.Draw(gameTime);


            // `ԁA"Draw"̑I
            timeRuler.EndMark("Draw");
        }


        /// <summary>
        /// Q[IuWFNg̏
        /// </summary>
        void InitializeGameObjects()
        {
            gameObjects = new GameObject[MaxGameObjectCount];
            gameObjectCount = InitialGameObjectCount;
            for (int i = 0; i < gameObjectCount; ++i)
                gameObjects[i].Initialize(rnd);
        }

        /// <summary>
        /// Q[IuWFNg̍XV
        /// </summary>
        void UpdateGameObjects(float dt)
        {
            // SIuWFNgXV
            // Q[IuWFNg̃CtԂɂāAQ[IuWFNg
            // Xg͂̂ŒPforeach͂ł͎gȂ
            for (int i = 0; i < gameObjectCount; )
            {
                if (gameObjects[i].Update(dt))
                {
                    ++i;
                }
                else
                {
                    // Q[IuWFNg̏
                    // Ō̃Q[IuWFNgƌ
                    GameObject temp = gameObjects[i];
                    gameObjects[i] = gameObjects[--gameObjectCount];
                    gameObjects[gameObjectCount] = temp;
                }
            }

            if (targetObjectCount < gameObjectCount)
                gameObjectCount = targetObjectCount;

            while (gameObjectCount < targetObjectCount)
            {
                gameObjects[gameObjectCount++].Initialize(rnd);
            }
        }

        /// <summary>
        /// Q[IuWFNg̕`
        /// </summary>
        void DrawGameObjects()
        {
            GraphicsDevice gd = GraphicsDevice;
            // gd.RenderState.AlphaBlendEnable = false;
            gd.RenderState.DepthBufferEnable = true;

            // ǉ
            // 򃂃f̃eNX`
            GraphicsDevice.RenderState.AlphaBlendEnable = true;
            GraphicsDevice.RenderState.AlphaBlendOperation = BlendFunction.Add;
            GraphicsDevice.RenderState.SourceBlend = Blend.SourceAlpha;
            GraphicsDevice.RenderState.DestinationBlend = Blend.InverseSourceAlpha;
            GraphicsDevice.RenderState.SeparateAlphaBlendEnabled = false;

            GraphicsDevice.RenderState.AlphaTestEnable = true;
            GraphicsDevice.RenderState.AlphaFunction = CompareFunction.Greater;
            GraphicsDevice.RenderState.ReferenceAlpha = 0;


            DrawGameObjectsWithShaderInstancing();
        }


        /// <summary>
        /// `@3
        /// VF[_[CX^Xgf̕`
        /// }eAob`ł̓IuWFNgDrawIndexedPrimitiveĂ΂邪
        /// VF[_[CX^Xł͕̃CX^X萔WX^Ɋi[
        /// DrawIndexedPrimitiveŕ̃f`悷B̃fł100̃f
        /// ܂Ƃ߂ĕ`悵ĂB
        /// </summary>
        void DrawGameObjectsWithShaderInstancing()
        {
            timeRuler.BeginMark(1, "Draw", Color.Yellow);

            // Q[IuWFNg`
            foreach (InstancedModelPart meshPart in instancedModel.ModelParts)
            {
                if (instanceParam0.Length < meshPart.MaxInstances)
                {
                    instanceParam0 = new Vector4[meshPart.MaxInstances];
                    instanceParam1 = new Vector4[meshPart.MaxInstances];
                }

                Effect effect = meshPart.Effect;

                meshPart.Begin(view, projection, cameraPosition);

                for (int objIdx = 0; objIdx < gameObjectCount; )
                {
                    int instanceCount =
                            Math.Min(gameObjectCount - objIdx, meshPart.MaxInstances);

                    // CX^X萔WX^Ɋi[ׂ̔zɊi[
                    for (int i = 0; i < instanceCount; ++i, ++objIdx)
                    {
                        instanceParam0[i].X = gameObjects[objIdx].Position.X;
                        instanceParam0[i].Y = gameObjects[objIdx].Position.Y;
                        instanceParam0[i].Z = gameObjects[objIdx].Position.Z;
                        instanceParam0[i].W = gameObjects[objIdx].Scale;

                        instanceParam1[i].X = gameObjects[objIdx].RotateAxis.X;
                        instanceParam1[i].Y = gameObjects[objIdx].RotateAxis.Y;
                        instanceParam1[i].Z = gameObjects[objIdx].RotateAxis.Z;
                        instanceParam1[i].W = gameObjects[objIdx].Rotation;
                    }

                    // CX^X萔WX^ɐݒ肷
                    effect.Parameters["ShaderInstanceParams0"].SetValue(instanceParam0);
                    effect.Parameters["ShaderInstanceParams1"].SetValue(instanceParam1);
                    effect.CommitChanges();

                    meshPart.Draw(instanceCount);
                }

                meshPart.End();
            }

            timeRuler.EndMark(1, "Draw");
        }
    }
}
