﻿using System.Runtime.InteropServices;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ShaderInstancingTest02
{
    // class ObjectInstanceVertex
    // {

    /// <summary>
    /// オブジェクトインスタンス格納用の頂点データ
    /// </summary>
    [StructLayout( LayoutKind.Sequential )]
    public struct ObjectInstanceVertex
    {
        public Vector3  Position;   // 座標
        public float    Scale;      // スケール
        public Vector3  RotateAxis; // 回転軸
        public float    Rotation;   // 回転

        /// <summary>
        /// 頂点宣言
        /// </summary>
        public static VertexElement[] VertexElements = {
            // Position, Scale (16バイト)
            new VertexElement(1, 0, VertexElementFormat.Vector4,
                                    VertexElementMethod.Default,
                                    VertexElementUsage.TextureCoordinate, 1),
            // RotateAxis, Rotation (16バイト)
            new VertexElement(1,16, VertexElementFormat.Vector4,
                                    VertexElementMethod.Default,
                                    VertexElementUsage.TextureCoordinate, 2),
        };

        /// <summary>
        /// ストライドの取得
        /// </summary>
        public static int SizeInBytes
        {
            get { return Marshal.SizeOf( typeof( ObjectInstanceVertex ) ); }
        }
    }
}
